package com.steerinfo.pretrack.pretracknotice.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.pretrack.pretracknotice.model.PreTrackNotice;
import com.steerinfo.pretrack.pretracknotice.service.IPreTrackNoticeService;
import com.steerinfo.util.CommonPage;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * PreTrackNotice RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-11-13 03:42
 * 类描述
 * 修订历史：
 * 日期：2020-11-13
 * 作者：generator
 * 参考：
 * 描述：PreTrackNotice RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/pretracknotices")
@Api(value = "/${api.version}/pretracknotices", tags = "汽车衡通知单信息 - PreTrackNoticeController")
public class PreTrackNoticeController extends BaseRESTfulController {

    @Autowired
    IPreTrackNoticeService preTrackNoticeService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("pretracknotice:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<PreTrackNotice> list = preTrackNoticeService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("pretracknotice:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<PreTrackNotice> list = preTrackNoticeService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }


    @ApiOperation(value = "创建", notes = "根据PreTrackNotice对象创建")
    @ApiImplicitParam(name = "preTrackNotice", value = "详细实体preTrackNotice", required = true, dataType = "PreTrackNotice")
    //@RequiresPermissions("pretracknotice:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute PreTrackNotice model) {
        try {
            PreTrackNotice preTrackNotice = preTrackNoticeService.add(model);
            return success(preTrackNotice);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("pretracknotice:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            PreTrackNotice preTrackNotice = preTrackNoticeService.getById(id);
            return success(preTrackNotice);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的preTrackNotice信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "preTrackNotice", value = "详细实体preTrackNotice", required = true, dataType = "PreTrackNotice")
    })
    //@RequiresPermissions("pretracknotice:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody PreTrackNotice model) {
        try {
            model.setId(id);
            PreTrackNotice preTrackNotice = preTrackNoticeService.modify(model);
            return success(preTrackNotice);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("pretracknotice:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                preTrackNoticeService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据PreTrackNotice对象创建")
    @ApiImplicitParam(name = "preTrackNotice", value = "详细实体preTrackNotice", required = true, dataType = "PreTrackNotice")
    @PostMapping(value = "/add")
    public RESTfulResult checkAndAdd(@RequestBody PreTrackNotice model) {
        try {
            String no = preTrackNoticeService.checkAndAdd(model);
            return success(no);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "修改", notes = "根据PreTrackNotice对象修改")
    @ApiImplicitParam(name = "preTrackNotice", value = "详细实体preTrackNotice", required = true, dataType = "PreTrackNotice")
    @PostMapping(value = "/update")
    public RESTfulResult checkAndUpdate(@RequestBody PreTrackNotice model) {
        try {
            String no = preTrackNoticeService.checkAndUpdate(model);
            return success(no);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "停用数据", notes = "根据PreTrackScale对象停用")
    @ApiImplicitParam(name = "model", value = "详细实体PreTrackScale", required = true, dataType = "PreTrackScale")
    @PostMapping(value = "/abolish")
    public RESTfulResult abolish(@RequestBody List<PreTrackNotice> models) {
        RESTfulResult rm = failed();
        try {
            int num = preTrackNoticeService.abolish(models);
            if (num >= 1) {
                return success(num);
            } else {
                return failed("停用失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "启用数据", notes = "根据PreTrackScale对象启用")
    @ApiImplicitParam(name = "model", value = "详细实体PreTrackScale", required = true, dataType = "PreTrackScale")
    @PostMapping(value = "/recover")
    public RESTfulResult recover(@RequestBody List<PreTrackNotice> models) {
        RESTfulResult rm = failed();
        try {
            int num = preTrackNoticeService.recover(models);
            if (num >= 1) {
                return success(num);
            } else {
                return failed("启用失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "查询按钮", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasematterinfo:view")
    @PostMapping(value = "/listLike")
    public RESTfulResult listLike(@RequestBody CommonPage<PreTrackNotice> model) {
        try {
            PageList<PreTrackNotice> pageInfo = preTrackNoticeService.listLike(model);
            return success(pageInfo);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "批量新增", notes = "根据PreTrackNotice对象创建")
    @ApiImplicitParam(name = "preTrackNotice", value = "详细实体preTrackNotice", required = true, dataType = "PreTrackNotice")
    @PostMapping(value = "/addList")
    public RESTfulResult checkAndAddList(@RequestBody List<PreTrackNotice> models) {
        try {
            int num = preTrackNoticeService.checkAndAddList(models);
            return success(num);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

}
